import pickle
import os
import sys
from   string             import lstrip, rstrip

class DevsProject(object):
  def __init__(self, path=None, components={}):
    self.path  = path
    self.components = components

  def setPath(self, path):
    self.path = path
    
  def getPath(self):
    return self.path
    
  def setComponents(self, components):
    self.components = components
  
  def getComponents(self):
    return self.components
    
  def addToSysPath(self):
    if(sys.path.count(self.path)<1):
      sys.path.insert(0, self.path)
      sys.path.insert(0, os.path.join(self.path, 'model'))
      sys.path.insert(0, os.path.join(self.path, 'lib'))
  
  def removeFromSysPath(self):
    if(sys.path.count(self.path)>0):
      sys.path.remove(self.path)    
      sys.path.remove(os.path.join(self.path, 'model'))
      sys.path.remove(os.path.join(self.path, 'lib'))
  
  def save(self):
    projectFile = open(os.path.join( self.path, "DevsProject.prj"), 'w')
    pickle.dump(self, projectFile)
    projectFile.close()
    
#  def load(self, prjFile):
#    projectFile = open(prjFile, 'r')
#    self = pickle.load(projectFile)
#    projectFile.close()

class ModelComponent(object):
  def __init__(self, modelName, modelType, parameters, sources):
    self.modelName  = modelName
    self.modelType  = modelType
    self.parameters = parameters
    self.sources    = sources      #Row title for the trace graph
                                   #For atomic model they are states
                                   #For coupled model they are instances
                                   #in the form of ModelInstance
    
  def __str__(self):
    return '%s (%s)' % (self.modelName, self.modelType)
    
  def isAtomic(self):
    if(self.modelType=='Atomic'):
      return True
    return False
    
  def isCoupled(self):
    if(self.modelType=='Coupled'):
      return True
    return False    
    
class ModelParameter(object):
  def __init__(self, pName, pType, pValue):
    self.name = pName
    self.type = pType
    self.value = pValue
    
  def __str__(self):
    return '%s(%s) %s' % (self.name, self.type, str(self.value))

class DevsInstance(object):
  def __init__(self, name, type): # , parameters):
    self.name = name
    self.type = type
    #self.parameters = parameters
