# CoupledDEVS model: Root 


from lib.DEVS import *
from lib.Simulator import *
from whrandom import *
from Generator import *
from Processor import *

class Root(CoupledDEVS):

  def __init__(self, qs, ia, ib, sa, sb):
    CoupledDEVS.__init__(self)
    self.qs = qs
    self.ia = ia
    self.ib = ib
    self.sa = sa
    self.sb = sb
    self.OUT = self.addOutPort()
    self.OUT.instName = 'OUT'
    self.OUT.instType = 'OutPort'
    self.DISCARD = self.addOutPort()
    self.DISCARD.instName = 'DISCARD'
    self.DISCARD.instType = 'OutPort'
    self.generator = self.addSubModel(Generator(ia=self.ia, ib=self.ib, szl=self.sa, szh=self.sb))
    self.generator.instName = 'generator'
    self.generator.instType = 'Generator'
    self.p1 = self.addSubModel(Processor(self.qs))
    self.p1.instName = 'p1'
    self.p1.instType = 'Processor'
    self.p2 = self.addSubModel(Processor(self.qs))
    self.p2.instName = 'p2'
    self.p2.instType = 'Processor'
    self.p3 = self.addSubModel(Processor(self.qs))
    self.p3.instName = 'p3'
    self.p3.instType = 'Processor'
    self.connectPorts(self.generator.OUT, self.p1.IN)
    self.connectPorts(self.p1.OUT, self.OUT)
    self.connectPorts(self.p1.DISCARD, self.p2.IN)
    self.connectPorts(self.p2.OUT, self.OUT)
    self.connectPorts(self.p2.DISCARD, self.p3.IN)
    self.connectPorts(self.p3.OUT, self.OUT)
    self.connectPorts(self.p3.DISCARD, self.DISCARD)