"""
__graph_portDevsV2.py___________________________________________________________

Automatically generated graphical appearance ---> MODIFY DIRECTLY WITH CAUTION
________________________________________________________________________________
"""
import tkFont

from graphEntity     import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_portDevsV2(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 62, 31
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None

        constObj = ATOM3Constraint(atribs,"changeColor","self.semanticObject.", [], [])
        constObj.setValue(('changeColor', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), '# changeColor \n"""\nMakes a visual difference between input ports and output ports\n"""\n\nif( self.semanticObject and self.dc ):\n    enumValue = self.semanticObject.portType.getValue()[1]\n    #print \'port type is \',enumValue\n    handler = self.gf84.getHandler() # This is the diamond shape\n    if( enumValue == 0 ):\n        #print \'port is input\'\n        self.dc.itemconfigure( handler, fill=\'slateblue1\' )\n    else:\n        #print \'port is output\'\n        self.dc.itemconfigure( handler, fill=\'slateblue\' )\n\n\n'))
        self.constraintList.append(constObj)
        self.graphForms = []
        self.imageDict = self.getImageDict()

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([32.0, 11.0, 32.0, 11.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_polygon(self.translate([23.0, 11.0, 32.0, 2.0, 41.0, 11.0, 32.0, 20.0]), tags = self.tag, stipple = '', width = 1, outline = 'black', fill = 'royalblue', smooth = 'False', splinesteps =  '12')
        self.gf84 = GraphicalForm(drawing, h, "gf84")
        self.graphForms.append(self.gf84)

        if self.semanticObject: drawText = self.semanticObject.name.toString()
        else: drawText = "<name>"
        font = tkFont.Font( family='System', size=12, weight='normal', slant='roman', underline=0)
        h = drawing.create_text(self.translate([31.0, 15.0, 31.0, 12.0])[:2], tags = self.tag, font=font, fill = 'black', anchor = 'n', text = drawText, width = '0', justify= 'left', stipple='' )
        self.attr_display["name"] = h
        self.gf82 = GraphicalForm(drawing, h, 'gf82', fontObject=font)
        self.graphForms.append(self.gf82)


    def changeColor(self,params):
        # changeColor 
        """
        Makes a visual difference between input ports and output ports
        """
        
        if( self.semanticObject and self.dc ):
            enumValue = self.semanticObject.portType.getValue()[1]
            #print 'port type is ',enumValue
            handler = self.gf84.getHandler() # This is the diamond shape
            if( enumValue == 0 ):
                #print 'port is input'
                self.dc.itemconfigure( handler, fill='slateblue1' )
            else:
                #print 'port is output'
                self.dc.itemconfigure( handler, fill='slateblue' )
        
        
        

    def postCondition( self, actionID, * params):
        if actionID ==  self.EDIT or actionID == self.CREATE:
             res = self.changeColor(params)
             if res: return res
        return None

    def preCondition( self, actionID, * params):
        return None

    def getImageDict( self ):
        imageDict = dict()

        return imageDict

new_class = graph_portDevsV2
