# muModelica Compiler Project
# Author: Steven Xu
# Modeling, Simulation and Design Lab (MSDL)
# School of Computer Science
# McGill University


import os,sys
from optparse import OptionParser
from string import replace

from FrontEnd.XMLReader import XMLReader
from FrontEnd.ASTbuilder import ASTbuilder


# ---------------------------------------------------------------------
class Parser:
    "The module loads a Modelica source file and generates an AST"
    def __init__(self):
	self.msg=""

    # parserPpath: the path of the parser (String)
    # parser: name of he parser (String), e.g. './xmlDumper'
    # filePath: path of the file to be parsed (String)
    # moFile: Modelica source file (String) 
    # xmlFile: thhe generated XML file (String)
    # label: AST label (String)
    # return: an AST (AST::ClassFile)
    def parse(self, parserPath, parser, filePath, moFile, \
		xmlFile, label):
	# the parser, and the pyGK module, have to be placed 
	# under the same diectory as mc.py
	#print "Mo path: ", filePath
	#print "loading: "+moFile
	if "/" in moFile:            
	    moFilePath = filePath + os.sep + moFile
	else:
	    moFilePath = filePath + os.sep + moFile

	if "/" in xmlFile:            
	    xmlFilePath = filePath + os.sep + xmlFile
	else:
	    xmlFilePath = filePath + os.sep + xmlFile

	self.msg=self.msg+"loading: "+moFile+"\n"
	os.spawnlpe(os.P_WAIT, parserPath+os.sep+parser, './'+parser, \
		   moFilePath, xmlFilePath, os.environ)

#		   moFile, xmlFile, os.environ)
	#print xmlFile+ " generated!"

	self.msg=self.msg+xmlFile+ " generated!"
	if "/" in xmlFile:            
	    xmlFilePath = parserPath + os.sep + xmlFile
	else:
	    xmlFilePath = filePath + os.sep + xmlFile

	pyGK_CatalogPath = parserPath + os.sep + \
			   "pyGK/XMLTools/catalog/catalog.txt"
    	xmlReader=XMLReader(label, xmlFilePath, pyGK_CatalogPath)
	#print "XML path: ", xmlFilePath

	pyGK_Graph = xmlReader.load(label)
	#print xmlFile+' loaded!'
	self.msg=self.msg+xmlFile+' loaded!'
	astBuilder = ASTbuilder(pyGK_Graph, label, filePath)
	return astBuilder.go()

    # filePath: path of the file to be loaded (including filename) (String)
    # pyGKPath: path of pyGK (String)
    # label: AST label (String)
    def loadXML(self, filePath, pyGKPath, label):
	pyGK_CatalogPath = pyGKPath + os.sep + \
                           "pyGK/XMLTools/catalog/catalog.txt"
	xmlReader=XMLReader(label, filePath, pyGK_CatalogPath)
	pyGK_Graph = xmlReader.load(label)
	astBuilder = ASTbuilder(pyGK_Graph, label, filePath)
	return astBuilder.go()

    #parserPpath: the path of the parser (String)
    # parser: name of he parser (String), e.g. './xmlDumper'
    # moFile: Modelica source file (String)
    # xmlFile: thhe generated XML file (String)
    # label: AST label (String)
    # return: an AST (AST::ClassFile)
    def parse2(self, parserPath, parser, filePath, moFile, xmlFile, label):
        # the parser, and the pyGK module, have to be placed
        # under the same diectory as mc.py
        print "Starting loading: "+moFile
        os.spawnlp(os.P_WAIT, parserPath, './'+parser, \
                   moFile, xmlFile)
        print xmlFile+ " has been generated!"
        xmlFilePath = filePath + os.sep + xmlFile
        pyGK_CatalogPath = parserPath + os.sep + \
                           "pyGK/XMLTools/catalog/catalog.txt"
        xmlReader=XMLReader(label, xmlFilePath, pyGK_CatalogPath)
        pyGK_Graph = xmlReader.load(label)
        print xmlFile+' loaded!'
        astBuilder = ASTbuilder(pyGK_Graph, label)
        return astBuilder.go()

