model SpringDamper
  "Linear 1D translational spring and damper in parallel"
  extends Compliant;
  parameter Real s_rel0=0 "unstretched spring length";
  parameter Real c = 1 "spring constant";
  parameter Real d = 1 "damping constant";
  Real v_rel "relative velocity between flange_a and flange_b";
equation
  v_rel = der(s_rel);
  f = c*(s_rel - s_rel0) + d*v_rel;
end SpringDamper;

