// This is only a template and not 'real' code
// It is designed to make the flattening procedure a lot easier
//   as it will pre-generate a (correct) AST

package flatten
        import devs.*;

        class NewAtomic
                dict X = dict();
                list timeLefts;
                Real elapsed = 0;

                function get_dstar
                        output list dStar;
                        Real minimal = 0;
                        list elems = list();
                algorithm
                        // Get the minimal value
                        minimal := timeAdvance();
                        if instA_timeLeft < minimal + 1e-10 then
                                elems.append(instA_state);
                        end if;

                        // Select if there are more than one
                        if len(elems) > 1 then
                                dStar := select(elems);
                        else
                                dStar := elems[0];
                        end if;
                end getdstar;

                function new_intTransition
                        Integer counter = 0;
                        list new = list();
                        list transitioned = list();
                        list first = list();
                        list elems = list();
                        Real ta = 0.0;
                        dict Y_inst = dict();

                        // Not really a list...
                        list dStar;
                algorithm
                        // Search for the element to transition
                        new := list();
                        counter := 0;

                        instA_timeLeft := instA_timeLeft - elapsed;
                        instA_elapsed := instA_elapsed + elapsed;

                        dStar := get_dstar();

                        if dStar == instantiationA then
                                // Call its output function
                                Y := outputFnc_modelA(instantiationA_state);
                                // And its internal transition function
                                instantiationA_state := intTransition_modelA(instantiationA_state);
                                Y := renamePorts(Y, instantiationA_name);
                                Y := mapConnections(Y);
                                instA_timeLeft := timeAdvance_modelA(instantiationA_state);
                                instA_elapsed := 0;

                                Y_inst := getInstances(Y, "inst_A");
                        
                                // And call all connected models for this output
                                instantiationB_state := extTransition_modelB(instantiationB_state, Y_inst, elapsed);
                                // And now reset its timeLeft
                                instB_timeLeft := timeAdvance_modelB(instantiationB_state);
                                instB_elapsed := 0;
                        end if;
                end new_intTransition;

                function new_select
                        // Nothing to do, as it will just be the exact same as the original one
                        input list immChildren;
                        output list child;
                algorithm
                        child := immChildren[0];
                end new_select;

                function new_extTransition
                        dict Y = dict();
                        dict X = dict();
                        list keys = list();
                        dict Y_inst = dict();
                algorithm
                        // Do all mappings of the connections
                        instA_timeLeft := instA_timeLeft - elapsed;
                        instA_elapsed := instA_elapsed + elapsed;
                        X["portname"] := peek(portname);
                        Y := mapConnections(X);
                        keys := getModelKeys(Y);
                        if keys.__contains__("inst_name") then
                                Y_inst := getInstances(Y, "inst_A");
                                // Call the components external transitions
                                instantiationB_state := extTransition_modelA(state_inst, Y_inst, instA_elapsed);
                                // Now also reset its timeleft value
                                instA_timeLeft := timeAdvance_modelA(state_inst);
                                instA_elapsed := 0;
                        end if;
                end new_extTransition;

                function new_timeAdvance
                        output Real timeSpan;
                algorithm
                        timeLefts := list();
                        timeLefts.append(instA_timeLeft);
                        timeSpan := min(timeLefts);
                        timeSpan := max(0, timeSpan);
                end new_timeAdvance;

                function new_outputFnc
                        dict outp = dict();
                        list dStar;
                algorithm
                        // Fill in all necessary pushes
                        dStar := get_dstar();
                        if dStar == instantiationA then
                                // Call its output function
                                outp := outputFnc_modelA(instantiationA_state);
                                outp := renamePorts(outp, instantiationA_name);
                        end if;
                        outp := mapConnections(outp);
                        poke(outportA, outp.get("a", None));
                end new_outputFnc;

                function mapConnections
                        input dict X;
                        output dict Y;
                algorithm
                        Y := dict();
                        if X.__contains__("b") then
                                Y["a"] := X["b"];
                        end if;
                end mapConnections;

                function getModelKeys
                        input dict X;
                        output list Y;
                        list keys;
                        Integer counter;
                        String key;
                        String new_key;
                        String searchname;
                        Integer length;
                algorithm
                        Y := list();
                        keys := X.keys();
                        counter := 0;
                        length := keys.__len__();
                        while counter < length loop
                                key := keys[counter];
                                if key.__contains__(name) then
                                        Y.append(name);
                                end if;
                                counter := counter + 1;
                        end while;
                end getModelKeys;

                function getInstances
                        input dict X;
                        input String name;
                        output dict Y;
                        list keys;
                        Integer counter;
                        String key;
                        String new_key;
                        String searchname;
                        Integer length;
                algorithm
                        Y := dict();
                        keys := X.keys();
                        counter := 0;
                        length := keys.__len__();
                        while counter < length loop
                                key := keys[counter];
                                if key.__contains__(name) then
                                        searchname := name + "_";
                                        new_key := key.split(searchname);
                                        new_key := new_key[1];
                                        Y[new_key] := X[key];
                                end if;
                                counter := counter + 1;
                        end while;
                end mapInstances;

                function renamePorts
                        input dict X;
                        input String name;
                        output dict Y = dict();
                        list keys = list();
                        String newname = "";
                        String key = "";
                        Integer counter = 0;
                        Integer length = 0;
                algorithm
                        keys := X.keys();
                        counter := 0;
                        length := keys.__len__();
                        while counter < length loop
                                key := keys[counter];
                                newname := name + "_" + key;
                                Y[newname] := X[key];
                                counter := counter + 1;
                        end while;
                end renamePorts;
        equation
        end NewAtomic;
end flatten;
