
import sys
import os.path
sys.path.append(os.path.expanduser('../../pydevs-old/pydevs/'))
from DEVS import *
from infinity import *
from random import randint
from simulator import *

class GeneratorState:
  generating = 'generating'
  def __init__(self):
    
    self.seqState = self.generating

  def __str__(self):
    strRep = ''
    strRep = strRep + "\nseqState: " + str(self.seqState)
    return strRep

  def toXML(self):
    strRep = ''
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>seqState</name>"
    strRep = strRep + "\n\t<type>Generator_SeqStates</type>"
    strRep = strRep + "\n\t<value>"+str(self.seqState)+"</value>"
    strRep = strRep + "\n</attribute>"
    return strRep

class ProcessorState:
  idle = 'idle'
  state_2 = 'state_2'
  def __init__(self):
    
    self.seqState = self.idle

  def __str__(self):
    strRep = ''
    strRep = strRep + "\nseqState: " + str(self.seqState)
    return strRep

  def toXML(self):
    strRep = ''
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>seqState</name>"
    strRep = strRep + "\n\t<type>Processor_SeqStates</type>"
    strRep = strRep + "\n\t<value>"+str(self.seqState)+"</value>"
    strRep = strRep + "\n</attribute>"
    return strRep

class Root( AtomicDEVS ):
  def __init__(self):
    AtomicDEVS.__init__(self)
    self.p_out = self.addOutPort("p_out")
    self.X = dict()
    self.timeLefts = None
    self.elapsed = 0
    self.ins_2_state = ProcessorState()
    self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
    self.ins_2_elapsed = 0
    self.ins_6_ins_3_state = ProcessorState()
    self.ins_6_ins_3_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_3_state)
    self.ins_6_ins_3_elapsed = 0
    self.ins_6_ins_4_state = ProcessorState()
    self.ins_6_ins_4_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_4_state)
    self.ins_6_ins_4_elapsed = 0
    self.ins_7_state = GeneratorState()
    self.ins_7_timeLeft = self.timeAdvance_Generator(self.ins_7_state)
    self.ins_7_elapsed = 0
    
  def extTransition_Processor( self, state, X, elapsed ):
    if(state.seqState == ProcessorState.idle):
      state.seqState = ProcessorState.state_2
      self.event = X.get("p_in", None)
    return state

  
  def intTransition_Processor( self, state ):
    if(state.seqState == ProcessorState.state_2):
      state.seqState = ProcessorState.idle
    return state

  
  def outputFnc_Processor( self, state ):
    Y=dict()
    evt = None
    if(state.seqState == ProcessorState.state_2):
      Y["p_out"] = self.event
    return Y

  
  def timeAdvance_Processor( self, state ):
    if(state.seqState == ProcessorState.idle):
      timespan = INFINITY

    if(state.seqState == ProcessorState.state_2):
      timespan = self.event.jobSize
    return timespan

  
  def intTransition_Generator( self, state ):
    if(state.seqState == GeneratorState.generating):
      state.seqState = GeneratorState.generating
    return state

  
  def outputFnc_Generator( self, state ):
    Y=dict()
    evt = None
    if(state.seqState == GeneratorState.generating):
      evt = Job(0.3)
      Y["p_out"] = evt
    return Y

  
  def timeAdvance_Generator( self, state ):
    if(state.seqState == GeneratorState.generating):
      timespan = 1
    return timespan

  
  def get_dstar( self ):
    minimal = 0
    elems = list()
    minimal = self.timeAdvance()

    if(self.ins_2_timeLeft < minimal + 1e-10):
      elems.append(self.ins_2_state)

    if(self.ins_6_ins_3_timeLeft < minimal + 1e-10):
      elems.append(self.ins_6_ins_3_state)

    if(self.ins_6_ins_4_timeLeft < minimal + 1e-10):
      elems.append(self.ins_6_ins_4_state)

    if(self.ins_7_timeLeft < minimal + 1e-10):
      elems.append(self.ins_7_state)

    if(len(elems) > 1):
      dStar = self.select(elems)
    else:
      dStar = elems[0]
    return dStar

  
  def intTransition( self ):
    counter = 0
    new = list()
    transitioned = list()
    first = list()
    elems = list()
    ta = 0.0
    Y_inst = dict()
    dStar = None
    new = list()

    counter = 0

    self.ins_2_timeLeft = self.ins_2_timeLeft - self.elapsed

    self.ins_6_ins_3_timeLeft = self.ins_6_ins_3_timeLeft - self.elapsed

    self.ins_6_ins_4_timeLeft = self.ins_6_ins_4_timeLeft - self.elapsed

    self.ins_7_timeLeft = self.ins_7_timeLeft - self.elapsed

    self.ins_2_elapsed = self.ins_2_elapsed + self.elapsed

    self.ins_6_ins_3_elapsed = self.ins_6_ins_3_elapsed + self.elapsed

    self.ins_6_ins_4_elapsed = self.ins_6_ins_4_elapsed + self.elapsed

    self.ins_7_elapsed = self.ins_7_elapsed + self.elapsed

    dStar = self.get_dstar()

    if(dStar == self.ins_2_state):
      self.Y = self.outputFnc_Processor(self.ins_2_state)
      self.ins_2_state = self.intTransition_Processor(self.ins_2_state)
      self.Y = self.renamePorts(self.Y, "ins_2")
      self.Y = self.mapConnections(self.Y)
      self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
      self.ins_2_elapsed = 0

    if(dStar == self.ins_6_ins_3_state):
      self.Y = self.outputFnc_Processor(self.ins_6_ins_3_state)
      self.ins_6_ins_3_state = self.intTransition_Processor(self.ins_6_ins_3_state)
      self.Y = self.renamePorts(self.Y, "ins_6_ins_3")
      self.Y = self.mapConnections(self.Y)
      self.ins_6_ins_3_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_3_state)
      self.ins_6_ins_3_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_6_ins_4")
      self.ins_6_ins_4_state = self.extTransition_Processor(self.ins_6_ins_4_state, Y_inst, self.elapsed)
      self.ins_6_ins_4_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_4_state)
      self.ins_6_ins_4_elapsed = 0

    if(dStar == self.ins_6_ins_4_state):
      self.Y = self.outputFnc_Processor(self.ins_6_ins_4_state)
      self.ins_6_ins_4_state = self.intTransition_Processor(self.ins_6_ins_4_state)
      self.Y = self.renamePorts(self.Y, "ins_6_ins_4")
      self.Y = self.mapConnections(self.Y)
      self.ins_6_ins_4_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_4_state)
      self.ins_6_ins_4_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_2")
      self.ins_2_state = self.extTransition_Processor(self.ins_2_state, Y_inst, self.elapsed)
      self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
      self.ins_2_elapsed = 0

    if(dStar == self.ins_7_state):
      self.Y = self.outputFnc_Generator(self.ins_7_state)
      self.ins_7_state = self.intTransition_Generator(self.ins_7_state)
      self.Y = self.renamePorts(self.Y, "ins_7")
      self.Y = self.mapConnections(self.Y)
      self.ins_7_timeLeft = self.timeAdvance_Generator(self.ins_7_state)
      self.ins_7_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_6_ins_3")
      self.ins_6_ins_3_state = self.extTransition_Processor(self.ins_6_ins_3_state, Y_inst, self.elapsed)
      self.ins_6_ins_3_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_3_state)
      self.ins_6_ins_3_elapsed = 0
    return self.state

  
  def select( self, immChildren ):
    child = immChildren[0]
    return child

  
  def extTransition( self ):
    Y = dict()
    X = dict()
    keys = list()
    Y_inst = dict()
    self.ins_2_timeLeft = self.ins_2_timeLeft - self.elapsed

    self.ins_6_ins_3_timeLeft = self.ins_6_ins_3_timeLeft - self.elapsed

    self.ins_6_ins_4_timeLeft = self.ins_6_ins_4_timeLeft - self.elapsed

    self.ins_7_timeLeft = self.ins_7_timeLeft - self.elapsed

    self.ins_2_elapsed = self.ins_2_elapsed + self.elapsed

    self.ins_6_ins_3_elapsed = self.ins_6_ins_3_elapsed + self.elapsed

    self.ins_6_ins_4_elapsed = self.ins_6_ins_4_elapsed + self.elapsed

    self.ins_7_elapsed = self.ins_7_elapsed + self.elapsed

    Y = self.mapConnections(X)

    keys = self.getModelKeys(Y)

    if(keys.__contains__("ins_2")):
      Y_inst = self.getInstances(Y, "ins_2")
      self.ins_2_state = self.extTransition_Processor(self.ins_2_state, Y_inst, self.ins_2_elapsed)
      self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
      self.ins_2_elapsed = 0

    if(keys.__contains__("ins_6_ins_3")):
      Y_inst = self.getInstances(Y, "ins_6_ins_3")
      self.ins_6_ins_3_state = self.extTransition_Processor(self.ins_6_ins_3_state, Y_inst, self.ins_6_ins_3_elapsed)
      self.ins_6_ins_3_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_3_state)
      self.ins_6_ins_3_elapsed = 0

    if(keys.__contains__("ins_6_ins_4")):
      Y_inst = self.getInstances(Y, "ins_6_ins_4")
      self.ins_6_ins_4_state = self.extTransition_Processor(self.ins_6_ins_4_state, Y_inst, self.ins_6_ins_4_elapsed)
      self.ins_6_ins_4_timeLeft = self.timeAdvance_Processor(self.ins_6_ins_4_state)
      self.ins_6_ins_4_elapsed = 0

    if(keys.__contains__("ins_7")):
      Y_inst = self.getInstances(Y, "ins_7")
      self.ins_7_state = extTransition_Generator(self.ins_7_state, Y_inst, self.ins_7_elapsed)
      self.ins_7_timeLeft = self.timeAdvance_Generator(self.ins_7_state)
      self.ins_7_elapsed = 0
    return self.state

  
  def timeAdvance( self ):
    self.timeLefts = list()

    self.timeLefts.append(self.ins_2_timeLeft)

    self.timeLefts.append(self.ins_6_ins_3_timeLeft)

    self.timeLefts.append(self.ins_6_ins_4_timeLeft)

    self.timeLefts.append(self.ins_7_timeLeft)

    timeSpan = min(self.timeLefts)
    return timeSpan

  
  def outputFnc( self ):
    outp = dict()
    dStar = None
    dStar = self.get_dstar()

    if(dStar == self.ins_2_state):
      outp = self.outputFnc_Processor(self.ins_2_state)
      outp = self.renamePorts(outp, "ins_2")

    if(dStar == self.ins_6_ins_3_state):
      outp = self.outputFnc_Processor(self.ins_6_ins_3_state)
      outp = self.renamePorts(outp, "ins_6_ins_3")

    if(dStar == self.ins_6_ins_4_state):
      outp = self.outputFnc_Processor(self.ins_6_ins_4_state)
      outp = self.renamePorts(outp, "ins_6_ins_4")

    if(dStar == self.ins_7_state):
      outp = self.outputFnc_Generator(self.ins_7_state)
      outp = self.renamePorts(outp, "ins_7")

    outp = self.mapConnections(outp)

    self.poke(self.p_out, outp.get("p_out", None))


  
  def mapConnections( self, X ):
    Y = dict()

    if(X.__contains__("ins_6_ins_3_p_out")):
      Y["ins_6_ins_4_p_in"] = X["ins_6_ins_3_p_out"]

    if(X.__contains__("ins_6_ins_4_p_out")):
      Y["ins_2_p_in"] = X["ins_6_ins_4_p_out"]

    if(X.__contains__("ins_7_p_out")):
      Y["ins_6_ins_3_p_in"] = X["ins_7_p_out"]

    if(X.__contains__("ins_2_p_out")):
      Y["p_out"] = X["ins_2_p_out"]
    return Y

  
  def getModelKeys( self, X ):
    keys = None
    counter = 0
    key = ""
    new_key = ""
    searchname = ""
    length = 0
    Y = list()

    keys = X.keys()

    counter = 0

    length = keys.__len__()

    while counter < length:
      key = keys[counter]
      if(key.__contains__("ins_2")):
        Y.append("ins_2")
      if(key.__contains__("ins_6_ins_3")):
        Y.append("ins_6_ins_3")
      if(key.__contains__("ins_6_ins_4")):
        Y.append("ins_6_ins_4")
      if(key.__contains__("ins_7")):
        Y.append("ins_7")
      counter = counter + 1
    return Y

  
  def getInstances( self, X, name ):
    keys = None
    counter = 0
    key = ""
    new_key = ""
    searchname = ""
    length = 0
    Y = dict()

    keys = X.keys()

    counter = 0

    length = keys.__len__()

    while counter < length:
      key = keys[counter]
      if(key.__contains__(name)):
        searchname = name + "_"
        new_key = key.split(searchname)
        new_key = new_key[1]
        Y[new_key] = X[key]
      counter = counter + 1
    return Y

  
  def renamePorts( self, X, name ):
    Y=dict()
    keys = list()
    newname = ""
    key = ""
    counter = 0
    length = 0
    keys = X.keys()

    counter = 0

    length = keys.__len__()

    while counter < length:
      key = keys[counter]
      newname = name + "_" + key
      Y[newname] = X[key]
      counter = counter + 1
    return Y


  def __str__(self):
    strRep = ''
    strRep = strRep + "\nX: " + str(self.X)
    strRep = strRep + "\ntimeLefts: "
    for item in self.timeLefts:
      strRep = strRep + "\n\t" + str(item)
    strRep = strRep + "\nelapsed: " + str(self.elapsed)
    strRep = strRep + "\nins_2_state: " + str(self.ins_2_state)
    strRep = strRep + "\nins_2_timeLeft: " + str(self.ins_2_timeLeft)
    strRep = strRep + "\nins_2_elapsed: " + str(self.ins_2_elapsed)
    strRep = strRep + "\nins_6_ins_3_state: " + str(self.ins_6_ins_3_state)
    strRep = strRep + "\nins_6_ins_3_timeLeft: " + str(self.ins_6_ins_3_timeLeft)
    strRep = strRep + "\nins_6_ins_3_elapsed: " + str(self.ins_6_ins_3_elapsed)
    strRep = strRep + "\nins_6_ins_4_state: " + str(self.ins_6_ins_4_state)
    strRep = strRep + "\nins_6_ins_4_timeLeft: " + str(self.ins_6_ins_4_timeLeft)
    strRep = strRep + "\nins_6_ins_4_elapsed: " + str(self.ins_6_ins_4_elapsed)
    strRep = strRep + "\nins_7_state: " + str(self.ins_7_state)
    strRep = strRep + "\nins_7_timeLeft: " + str(self.ins_7_timeLeft)
    strRep = strRep + "\nins_7_elapsed: " + str(self.ins_7_elapsed)
    return strRep

  def toXML(self):
    strRep = ''
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>X</name>"
    strRep = strRep + "\n\t<type>dict</type>"
    if(self.X!=None):
      strRep = strRep + "\n\t<value>"+self.X.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>timeLefts</name>"
    strRep = strRep + "\n\t<type>list</type>"
    strRep = strRep + "\n\t<value>"
    for item in self.timeLefts:
      strRep = strRep + "\n\t" + item.toXML()
    strRep = strRep + "\n\t</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_2_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_2_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_2_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_2_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_2_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_2_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_2_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_6_ins_3_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_6_ins_3_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_6_ins_3_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_6_ins_3_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_6_ins_3_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_6_ins_3_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_6_ins_3_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_6_ins_4_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_6_ins_4_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_6_ins_4_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_6_ins_4_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_6_ins_4_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_6_ins_4_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_6_ins_4_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_7_state</name>"
    strRep = strRep + "\n\t<type>GeneratorState</type>"
    if(self.ins_7_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_7_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_7_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_7_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_7_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_7_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    return strRep

class Job( object ):
  def __init__(self, jobSize):
    self.jobSize = jobSize

  def __str__(self):
    strRep = ''
    return strRep

  def toXML(self):
    strRep = ''
    return strRep

class Experiment( object ):
  def __init__(self):
    self.rootModel = Root()
    self.sim = Simulator(model = self.rootModel)
    self.verbose = False
    self.end_time = 10000
  def simulate(self):
    self.sim.simulate(termination_condition=terminate_at(self.end_time), verbose=self.verbose)




def terminate_at(t):
 def f(model, clock):
  if clock >= t:
    return True
  else:
    return False
 return f
if __name__ == '__main__':
  experiment = Experiment()
  experiment.simulate()
