package test
  import devs.*;
  import externalfunctions.*;
  import simulator.*;
  class GeneratorState
    type Generator_SeqStates
      EnumType value;
      parameter StringType quantity="";
      parameter EnumType min=generating, max=generating;
      parameter EnumType start=generating;
      parameter BooleanType fixed=false;
      parameter BooleanType enable=true;
      constant EnumType generating;
    end Generator_SeqStates;
    Generator_SeqStates seqState(start=generating);
  end GeneratorState;
  class ProcessorState
    type Processor_SeqStates
      EnumType value;
      parameter StringType quantity="";
      parameter EnumType min=idle, max=state_2;
      parameter EnumType start=idle;
      parameter BooleanType fixed=false;
      parameter BooleanType enable=true;
      constant EnumType idle;
      constant EnumType state_2;
    end Processor_SeqStates;
    Processor_SeqStates seqState(start=idle);
  end ProcessorState;
  class Root
    extends AtomicDEVS;
    extends AtomicDEVS;
    extends AtomicDEVS;
    extends AtomicDEVS;
    output DevsPort p_out;
    dict X=dict();
    list timeLefts;
    Real elapsed=0;
    ProcessorState ins_2_state=ProcessorState();
    Real ins_2_timeLeft=timeAdvance_Processor(ins_2_state);
    Real ins_2_elapsed=0;
    ProcessorState ins_6_ins_3_state=ProcessorState();
    Real ins_6_ins_3_timeLeft=timeAdvance_Processor(ins_6_ins_3_state);
    Real ins_6_ins_3_elapsed=0;
    ProcessorState ins_6_ins_4_state=ProcessorState();
    Real ins_6_ins_4_timeLeft=timeAdvance_Processor(ins_6_ins_4_state);
    Real ins_6_ins_4_elapsed=0;
    GeneratorState ins_7_state=GeneratorState();
    Real ins_7_timeLeft=timeAdvance_Generator(ins_7_state);
    Real ins_7_elapsed=0;
    function extTransition_Processor
      input ProcessorState state;
      input dict X;
      input Integer elapsed;
    algorithm 
      if state.seqState == ProcessorState.idle then
        state.seqState := ProcessorState.state_2;
        event := X.get("p_in", None);
      end if;
    end extTransition_Processor;
    function intTransition_Processor
      input ProcessorState state;
    algorithm 
      if state.seqState == ProcessorState.state_2 then
        state.seqState := ProcessorState.idle;
      end if;
    end intTransition_Processor;
    function outputFnc_Processor
      DevsEvent evt=null;
      input ProcessorState state;
      output dict Y=dict();
    algorithm 
      if state.seqState == ProcessorState.state_2 then
        Y["p_out"] := event;
      end if;
    end outputFnc_Processor;
    function timeAdvance_Processor
      output Integer timespan;
      input ProcessorState state;
    algorithm 
      if state.seqState == ProcessorState.idle then
        timespan := INFINITY;
      end if;
      if state.seqState == ProcessorState.state_2 then
        timespan := event.jobSize;
      end if;
    end timeAdvance_Processor;
    function intTransition_Generator
      input GeneratorState state;
    algorithm 
      if state.seqState == GeneratorState.generating then
        state.seqState := GeneratorState.generating;
      end if;
    end intTransition_Generator;
    function outputFnc_Generator
      DevsEvent evt=null;
      input GeneratorState state;
      output dict Y=dict();
    algorithm 
      if state.seqState == GeneratorState.generating then
        evt := Job(0.3);
        Y["p_out"] := evt;
      end if;
    end outputFnc_Generator;
    function timeAdvance_Generator
      output Integer timespan;
      input GeneratorState state;
    algorithm 
      if state.seqState == GeneratorState.generating then
        timespan := 1;
      end if;
    end timeAdvance_Generator;
    function get_dstar
      output list dStar;
      Real minimal=0;
      list elems=list();
    algorithm 
      minimal := timeAdvance();
      if ins_2_timeLeft < minimal+1e-10 then
        elems.append(ins_2_state);
      end if;
      if ins_6_ins_3_timeLeft < minimal+1e-10 then
        elems.append(ins_6_ins_3_state);
      end if;
      if ins_6_ins_4_timeLeft < minimal+1e-10 then
        elems.append(ins_6_ins_4_state);
      end if;
      if ins_7_timeLeft < minimal+1e-10 then
        elems.append(ins_7_state);
      end if;
      if len(elems) > 1 then
        dStar := select(elems);
      else
        dStar := elems[0];
      end if;
    end get_dstar;
    function intTransition
      Integer counter=0;
      list new=list();
      list transitioned=list();
      list first=list();
      list elems=list();
      Real ta=0.0;
      dict Y_inst=dict();
      list dStar;
    algorithm 
      new := list();
      counter := 0;
      ins_2_timeLeft := ins_2_timeLeft-elapsed;
      ins_6_ins_3_timeLeft := ins_6_ins_3_timeLeft-elapsed;
      ins_6_ins_4_timeLeft := ins_6_ins_4_timeLeft-elapsed;
      ins_7_timeLeft := ins_7_timeLeft-elapsed;
      ins_2_elapsed := ins_2_elapsed+elapsed;
      ins_6_ins_3_elapsed := ins_6_ins_3_elapsed+elapsed;
      ins_6_ins_4_elapsed := ins_6_ins_4_elapsed+elapsed;
      ins_7_elapsed := ins_7_elapsed+elapsed;
      dStar := get_dstar();
      if dStar == ins_2_state then
        Y := outputFnc_Processor(ins_2_state);
        ins_2_state := intTransition_Processor(ins_2_state);
        Y := renamePorts(Y,"ins_2");
        Y := mapConnections(Y);
        ins_2_timeLeft := timeAdvance_Processor(ins_2_state);
        ins_2_elapsed := 0;
      end if;
      if dStar == ins_6_ins_3_state then
        Y := outputFnc_Processor(ins_6_ins_3_state);
        ins_6_ins_3_state := intTransition_Processor(ins_6_ins_3_state);
        Y := renamePorts(Y,"ins_6_ins_3");
        Y := mapConnections(Y);
        ins_6_ins_3_timeLeft := timeAdvance_Processor(ins_6_ins_3_state);
        ins_6_ins_3_elapsed := 0;
        Y_inst := getInstances(Y,"ins_6_ins_4");
        ins_6_ins_4_state := extTransition_Processor(ins_6_ins_4_state,Y_inst,elapsed);
        ins_6_ins_4_timeLeft := timeAdvance_Processor(ins_6_ins_4_state);
        ins_6_ins_4_elapsed := 0;
      end if;
      if dStar == ins_6_ins_4_state then
        Y := outputFnc_Processor(ins_6_ins_4_state);
        ins_6_ins_4_state := intTransition_Processor(ins_6_ins_4_state);
        Y := renamePorts(Y,"ins_6_ins_4");
        Y := mapConnections(Y);
        ins_6_ins_4_timeLeft := timeAdvance_Processor(ins_6_ins_4_state);
        ins_6_ins_4_elapsed := 0;
        Y_inst := getInstances(Y,"ins_2");
        ins_2_state := extTransition_Processor(ins_2_state,Y_inst,elapsed);
        ins_2_timeLeft := timeAdvance_Processor(ins_2_state);
        ins_2_elapsed := 0;
      end if;
      if dStar == ins_7_state then
        Y := outputFnc_Generator(ins_7_state);
        ins_7_state := intTransition_Generator(ins_7_state);
        Y := renamePorts(Y,"ins_7");
        Y := mapConnections(Y);
        ins_7_timeLeft := timeAdvance_Generator(ins_7_state);
        ins_7_elapsed := 0;
        Y_inst := getInstances(Y,"ins_6_ins_3");
        ins_6_ins_3_state := extTransition_Processor(ins_6_ins_3_state,Y_inst,elapsed);
        ins_6_ins_3_timeLeft := timeAdvance_Processor(ins_6_ins_3_state);
        ins_6_ins_3_elapsed := 0;
      end if;
    end intTransition;
    function select
      input list immChildren;
      output list child;
    algorithm 
      child := immChildren[0];
    end select;
    function extTransition
      dict Y=dict();
      dict X=dict();
      list keys=list();
      dict Y_inst=dict();
    algorithm 
      ins_2_timeLeft := ins_2_timeLeft-elapsed;
      ins_6_ins_3_timeLeft := ins_6_ins_3_timeLeft-elapsed;
      ins_6_ins_4_timeLeft := ins_6_ins_4_timeLeft-elapsed;
      ins_7_timeLeft := ins_7_timeLeft-elapsed;
      ins_2_elapsed := ins_2_elapsed+elapsed;
      ins_6_ins_3_elapsed := ins_6_ins_3_elapsed+elapsed;
      ins_6_ins_4_elapsed := ins_6_ins_4_elapsed+elapsed;
      ins_7_elapsed := ins_7_elapsed+elapsed;
      Y := mapConnections(X);
      keys := getModelKeys(Y);
      if keys.__contains__("ins_2") then
        Y_inst := getInstances(Y,"ins_2");
        ins_2_state := extTransition_Processor(ins_2_state,Y_inst,ins_2_elapsed);
        ins_2_timeLeft := timeAdvance_Processor(ins_2_state);
        ins_2_elapsed := 0;
      end if;
      if keys.__contains__("ins_6_ins_3") then
        Y_inst := getInstances(Y,"ins_6_ins_3");
        ins_6_ins_3_state := extTransition_Processor(ins_6_ins_3_state,Y_inst,ins_6_ins_3_elapsed);
        ins_6_ins_3_timeLeft := timeAdvance_Processor(ins_6_ins_3_state);
        ins_6_ins_3_elapsed := 0;
      end if;
      if keys.__contains__("ins_6_ins_4") then
        Y_inst := getInstances(Y,"ins_6_ins_4");
        ins_6_ins_4_state := extTransition_Processor(ins_6_ins_4_state,Y_inst,ins_6_ins_4_elapsed);
        ins_6_ins_4_timeLeft := timeAdvance_Processor(ins_6_ins_4_state);
        ins_6_ins_4_elapsed := 0;
      end if;
      if keys.__contains__("ins_7") then
        Y_inst := getInstances(Y,"ins_7");
        ins_7_state := extTransition_Generator(ins_7_state,Y_inst,ins_7_elapsed);
        ins_7_timeLeft := timeAdvance_Generator(ins_7_state);
        ins_7_elapsed := 0;
      end if;
    end extTransition;
    function timeAdvance
      output Real timeSpan;
    algorithm 
      timeLefts := list();
      timeLefts.append(ins_2_timeLeft);
      timeLefts.append(ins_6_ins_3_timeLeft);
      timeLefts.append(ins_6_ins_4_timeLeft);
      timeLefts.append(ins_7_timeLeft);
      timeSpan := min(timeLefts);
    end timeAdvance;
    function outputFnc
      dict outp=dict();
      list dStar;
    algorithm 
      dStar := get_dstar();
      if dStar == ins_2_state then
        outp := outputFnc_Processor(ins_2_state);
        outp := renamePorts(outp,"ins_2");
      end if;
      if dStar == ins_6_ins_3_state then
        outp := outputFnc_Processor(ins_6_ins_3_state);
        outp := renamePorts(outp,"ins_6_ins_3");
      end if;
      if dStar == ins_6_ins_4_state then
        outp := outputFnc_Processor(ins_6_ins_4_state);
        outp := renamePorts(outp,"ins_6_ins_4");
      end if;
      if dStar == ins_7_state then
        outp := outputFnc_Generator(ins_7_state);
        outp := renamePorts(outp,"ins_7");
      end if;
      outp := mapConnections(outp);
      poke(p_out,outp.get("p_out",None));
    end outputFnc;
    function mapConnections
      input dict X;
      output dict Y;
    algorithm 
      Y := dict();
      if X.__contains__("ins_6_ins_3_p_out") then
        Y["ins_6_ins_4_p_in"] := X["ins_6_ins_3_p_out"];
      end if;
      if X.__contains__("ins_6_ins_4_p_out") then
        Y["ins_2_p_in"] := X["ins_6_ins_4_p_out"];
      end if;
      if X.__contains__("ins_7_p_out") then
        Y["ins_6_ins_3_p_in"] := X["ins_7_p_out"];
      end if;
      if X.__contains__("ins_2_p_out") then
        Y["p_out"] := X["ins_2_p_out"];
      end if;
    end mapConnections;
    function getModelKeys
      input dict X;
      output list Y;
      list keys;
      Integer counter;
      String key;
      String new_key;
      String searchname;
      Integer length;
    algorithm 
      Y := list();
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        if key.__contains__("ins_2") then
          Y.append("ins_2");
        end if;
        if key.__contains__("ins_6_ins_3") then
          Y.append("ins_6_ins_3");
        end if;
        if key.__contains__("ins_6_ins_4") then
          Y.append("ins_6_ins_4");
        end if;
        if key.__contains__("ins_7") then
          Y.append("ins_7");
        end if;
        counter := counter+1;
      end while;
    end getModelKeys;
    function getInstances
      input dict X;
      input String name;
      output dict Y;
      list keys;
      Integer counter;
      String key;
      String new_key;
      String searchname;
      Integer length;
    algorithm 
      Y := dict();
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        if key.__contains__(name) then
          searchname := name+"_";
          new_key := key.split(searchname);
          new_key := new_key[1];
          Y[new_key] := X[key];
        end if;
        counter := counter+1;
      end while;
    end getInstances;
    function renamePorts
      input dict X;
      input String name;
      output dict Y=dict();
      list keys=list();
      String newname="";
      String key="";
      Integer counter=0;
      Integer length=0;
    algorithm 
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        newname := name+"_"+key;
        Y[newname] := X[key];
        counter := counter+1;
      end while;
    end renamePorts;
  end Root;
  class Job
    extends DevsEvent;
    parameter Real jobSize;
  end Job;
  class Experiment
    extends DevsExperiment;
    Root rootModel();
    Simulator sim(simModel=rootModel);
    Boolean verbose=True;
    Boolean trace=False;
    Real end_time=100.0;
  end Experiment;
end test;