
package test
  import devs.*;
  import externalfunctions.*;
  import simulator.*;

  class GeneratorState
    Generator.SeqStates seqState(start=Generator.SeqStates.generating);
  end GeneratorState;

  class Generator
    extends AtomicDEVS;
    parameter String name;
    output DevsPort p_out;
    GeneratorState state();
    type SeqStates = enumeration(generating);

    function intTransition
    algorithm
      if( state.seqState == SeqStates.generating ) then
        // Use Modelica syntax
        state.seqState := SeqStates.generating;
      end if;
    end intTransition;

    function outputFnc
      DevsEvent evt = null;
    algorithm
      if( state.seqState == SeqStates.generating) then
        evt := Job(0.3);
        poke(p_out, evt);
      end if;
    end outputFnc;

    function timeAdvance
      output Integer timespan;
    algorithm
      if( state.seqState == SeqStates.generating) then
        timespan := 1;
      end if;
    end timeAdvance;

  end Generator;

  class ProcessorState
    Processor.SeqStates seqState(start=Processor.SeqStates.idle);
  end ProcessorState;

  class Processor
    extends AtomicDEVS;
    parameter String name;
    input DevsPort p_in;
    output DevsPort p_out;
    ProcessorState state();
    type SeqStates = enumeration(idle, state_2);

    function extTransition
    algorithm
      if( state.seqState == SeqStates.idle ) then
        // Use Modelica syntax
        state.seqState := SeqStates.state_2;
      event := peek(p_in);
      end if;
    end extTransition;


    function intTransition
    algorithm
      // Use Modelica syntax
      if( state.seqState == SeqStates.state_2 ) then
        // Use Modelica syntax
        state.seqState := SeqStates.idle;
      end if;
    end intTransition;

    function outputFnc
      DevsEvent evt = null;
    algorithm
      if( state.seqState == SeqStates.state_2) then
        poke(p_out, event);
      end if;
    end outputFnc;

    function timeAdvance
      output Integer timespan;
    algorithm
      if( state.seqState == SeqStates.idle) then
        timespan := INFINITY;
      end if;
      if( state.seqState == SeqStates.state_2) then
        timespan := event.jobSize;
      end if;
    end timeAdvance;

  end Processor;

  class RootX
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end RootX;

  class Job
    extends DevsEvent;
    parameter Real jobSize;
  end Job;

  class Experiment
    extends DevsExperiment;
    RootY rootModel(name="Experiment");
    Simulator sim(simModel=rootModel);
    Boolean verbose = False;
    Boolean trace = False;
    Real end_time = 1000;
  end Experiment;

  class Root0
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root0;

  class Root1
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root1;

  class Root2
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root2;

  class Root3
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root3;

  class Root4
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root4;

  class Root5
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root5;

  class Root6
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root6;

  class Root7
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root7;

  class Root8
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root8;

  class Root9
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root9;

  class Root10
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root10;

  class Root11
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root11;

  class Root12
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root12;

  class Root13
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root13;

  class Root14
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root14;

  class Root15
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root15;

  class Root16
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root16;

  class Root17
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root17;

  class Root18
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root18;

  class Root19
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root19;

  class Root20
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root20;

  class Root21
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root21;

  class Root22
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root22;

  class Root23
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root23;

  class Root24
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root24;

  class Root25
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root25;

  class Root26
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root26;

  class Root27
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root27;

  class Root28
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root28;

  class Root29
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root29;

  class Root30
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root30;

  class Root31
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root31;

  class Root32
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root32;

  class Root33
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root33;

  class Root34
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root34;

  class Root35
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root35;

  class Root36
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root36;

  class Root37
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root37;

  class Root38
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root38;

  class Root39
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root39;

  class Root40
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root40;

  class Root41
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root41;

  class Root42
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root42;

  class Root43
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root43;

  class Root44
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root44;

  class Root45
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root45;

  class Root46
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root46;

  class Root47
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root47;

  class Root48
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root48;

  class Root49
    extends CoupledDEVS;
    parameter String name;
    output DevsPort p_out;
    input DevsPort p_in;
    DECLS
  equation
    CONNECTS
  end Root49;

end test;
