from GraphRepr.GraphUtils.Iterator import Iterator
from GraphRepr.GraphUtils.Error.IteratorException\
                            import NoMoreElementException,\
                                   TypeInvalidityException,\
                                   InvalidKeyException


class ConnIterator(Iterator):

    def __sort(self, elemDict):
        elems=[]
        for key in elemDict.keys():
            elems.append(elemDict[key])
        elems.sort(lambda x, y: cmp(x[1], y[1]))
        return elems

    def __init__(self, elemDict):
        self.__elems=self.__sort(elemDict)
        self.__current=0

    def first(self):
        self.__current=0

    def next(self):
        if self.isDone():
            raise NoMoreElementException()
        else:
            self.__current+=1

    def currentElement(self):
        if self.isDone():
            raise NoMoreElementException()
        else:
            return self.__elems[self.__current][0]

    def isDone(self):
        return self.__current>=len(self.__elems)


