from GraphRepr.GraphUtils.ElemIterator import ElemIterator

from GraphRepr.GraphUtils.Collection import Collection
from GraphRepr.GraphUtils.Error.CollectionException\
                            import InvalidElementException

class GraphElemCollection(Collection):

    def __init__(self, dictOfElem, dictOfList):
        self.__elems=dictOfElem
        self.__dict=dictOfList

    def size(self):
        return len(self.__elems)

    def hasElement(self, local_ID):
        if self.__elems.has_key(local_ID):
            return 1
        return 0

    def getElement(self, local_ID):
        if not self.hasElement(local_ID):
            raise InvalidElementException(local_ID)
        return self.__elems[local_ID]

    def getElementsOfType(self, typeName):
        answer = []
        if not self.__dict.has_key(typeName):
            return answer
        else:
            for item in self.__dict[typeName]:
                answer.append(item)
        return answer

    def getElements(self):
        answer=[]
        for key in self.__elems.keys():
            answer.append(self.__elems[key])
        return answer

    def iterate(self, typeList=None):
        return ElemIterator(self.__dict, typeList)


    def __str__(self):
        return str(self.__elems)



