# Abstract Class MappingType
# Authors Marc Provost
# Super class for the hard-coded mapping types:
# For now: SymbolTable

from GraphRepr.Node import Node
from GraphRepr.Graph import Graph

import exceptions
from exceptions import NotImplementedError

class MappingType:

    TYPE=Graph("MappingType")
    TYPE.addElement(Node("MappingType"))
    TYPE.addElement(Node("SymbolTable", type="MappingType"))

    def __init__(self, LIST=[]):
        raise NotImplementedError("Abstract Class")

    # Add an element to this mapping
    # key : any Object
    # elem : GraphElement
    def addElement(self, key, elem):
        pass

    # Remove an element to this mapping
    # elem : GraphElement
    def removeElement(self, key):
        pass

    # Check if elem is member of this mapping
    # elem : GraphElement
    def hasElement(self, key):
        pass

    # Retrieve the element from this mapping
    # returnVal: GraphElement
    def getElement(self, key):
        pass

    # returns the size of this mapping
    # returnVal: int
    def size(self):
        pass

    # returns the keys of this mapping
    # returnVal : List (obj)
    def keys(self):
        pass

    # OVERLOADING METHODS

    # get the item at key
    # key : any Obj
    # returnVal : GraphElement
    def __getitem__(self, key):
        pass

    # set the item at key
    # key : any obj
    # item : GraphElement
    def __setitem__(self, key, item):
        pass

    # del the item at key
    # key : any obj
    def __delitem__(self, key):
        pass

    # returns true if key is in this mapping
    # returnVal: boolean
    def __contains__(self, key):
        pass

    # returns the number of elements in the mapping
    def __len__(self):
        pass

    # returns an hashing value for this object
    def __hash__(self):
        pass

    def __str__(self):
        pass