from GraphRepr.Types.SimpleType.Int import Int
from GraphRepr.Types.SimpleType.Bool import Bool
from GraphRepr.Types.SimpleType.String import String
from GraphRepr.Types.SimpleType.Float import Float

from GraphRepr.Types.MappingType.SymbolTable import SymbolTable

from GraphRepr.Graph import Graph
from GraphRepr.Node import Node

import unittest

class MappingTypeSuccess(unittest.TestCase):

    sampleSuccess = [ [Int(5, "0"), Bool("true","1"), String("blah","2"),
                       Float(4.5,"3"), Int(10,"4")]
                    ]

    def testBasicSymbolTable(self):
        """Testing SymbolTable
        """

        for sample in self.sampleSuccess:
            lst = SymbolTable()

            for el in sample:
                lst[el.getLocalId()]=el

            self.failIf(len(sample) != lst.size(),
                        "sizes do not correspond")

            for el in sample:
                self.failIf(not lst.hasElement(el.getLocalId()),
                            "some element is not present!")

            for key in lst.keys():
                self.failIf(not lst.hasElement(key),
                            "some element is not present!")
                self.failIf(not lst[key] in sample,
                            "some element is not in the sample")


            del lst[sample[0].getLocalId()]

            self.failIf(lst.hasElement(sample[0].getLocalId()),
                        "some deleted element is still there")





if __name__ == "__main__":
    unittest.main()



