import os,sys

sep=os.sep
pathsep=os.pathsep

pathname = os.path.dirname(sys.argv[0])
rootDir = os.path.abspath(pathname)
curValue = ""

print "Higraph kernel V1.0 BETA"
print ""
print "%%%%% Setup Script %%%%%"
print ""
print ""

catPath=rootDir+sep+"XMLTools"+sep+"catalog"+sep+"catalog.txt"

print "Creating the catalog file at: " + catPath

cat = open(catPath, 'w')

cat.write("-- AGL --\n")
cat.write("\n")
cat.write("SYSTEM http://agl.dtd " + rootDir+sep+"XMLTools"+sep+\
                                     "dtd"+sep+"agl.dtd")

cat.close()

print "Creating the batch test script at: " + str(rootDir + sep+"test.bat")
test_batch = open(rootDir + sep+"test.bat", 'w')

test_batch.write("ECHO OFF\n")
test_batch.write("ECHO ****TEST SCRIPT FOR ATOM^3 V1.0****\n")
test_batch.write("ECHO *****Testing SimpleType module*****\n")
test_batch.write("python GraphRepr"+sep+"Types"+sep+"SimpleType"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing CollectionType module*****\n")
test_batch.write("python GraphRepr"+sep+"Types"+sep+"CollectionType"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing MappingType module*****\n")
test_batch.write("python GraphRepr"+sep+"Types"+sep+"MappingType"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing GraphUtils module*****\n")
test_batch.write("python GraphRepr"+sep+"GraphUtils"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing GraphRepr module*****\n")
test_batch.write("python GraphRepr"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing AGLGenerator module*****\n")
test_batch.write("python GraphManager"+sep+"AGLGenerator"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing AGLLoader module*****\n")
test_batch.write("python GraphManager"+sep+"AGLLoader"+sep+"Test"+sep+"TestSuite.py -v\n")
test_batch.write("ECHO *****Testing GraphManager module*****\n")
test_batch.write("python GraphManager"+sep+"Test"+sep+"TestSuite.py -v\n")
#test_batch.write("ECHO *****Testing Graph Matching module*****\n")
#test_batch.write("python GG"+sep+"MatchAlg"+sep+"Test"+sep+"TestSuite.py -v\n")
#test_batch.write("ECHO *****Testing Graph Rewriting system module*****\n")
#test_batch.write("python GG"+sep+"GRSystem"+sep+"Test"+sep+"TestSuite.py -v\n")

print "Creating the shell test script at: " + str(rootDir+sep+"test.sh")
test_sh = open(rootDir+sep+"test.sh",'w')

test_sh.write("#!/bin/bash\n")
test_sh.write("echo \"****TEST SCRIPT FOR ATOM^3 V1.0****\"\n")
test_sh.write("echo \"*****Testing SimpleType module*****\"\n")
test_sh.write("python GraphRepr"+sep+"Types"+sep+"SimpleType"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing CollectionType module*****\"\n")
test_sh.write("python GraphRepr"+sep+"Types"+sep+"CollectionType"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing MappingType module*****\"\n")
test_sh.write("python GraphRepr"+sep+"Types"+sep+"MappingType"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing GraphUtils module*****\"\n")
test_sh.write("python GraphRepr"+sep+"GraphUtils"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing GraphRepr module*****\"\n")
test_sh.write("python GraphRepr"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing AGLGenerator module*****\"\n")
test_sh.write("python GraphManager"+sep+"AGLGenerator"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing AGLLoader module*****\"\n")
test_sh.write("python GraphManager"+sep+"AGLLoader"+sep+"Test"+sep+"TestSuite.py -v\n")
test_sh.write("echo \"*****Testing GraphManager module*****\"\n")
test_sh.write("python GraphManager"+sep+"Test"+sep+"TestSuite.py -v\n")
#test_sh.write("echo \"*****Testing Graph Matching module*****\"\n")
#test_sh.write("python GG"+sep+"MatchAlg"+sep+"Test"+sep+"TestSuite.py -v\n")
#test_sh.write("echo \"*****Testing Graph Rewriting system module*****\"\n")
#test_sh.write("python GG"+sep+"GRSystem"+sep+"Test"+sep+"TestSuite.py -v\n")

print ""
print ""
print "****************************************************"
print "This path: "
print ""
print rootDir
print ""
print "must be added to the PYTHONPATH environment variable"
print "****************************************************"

