#!/bin/bash
source setPATH > /dev/null
cd performancetest
TIMEFORMAT=%U

function runsim {
        for length in 3 4 5 6 7 8 9 10 15 20 25 30 35 40 50
        do
                echo -n "$length "
                python $1 $length
                cp out.mo ../test.mo
                cd ..
                python devsmc.py -f test.mo
                python devsmc.py test.flat.mo
                python devsmc.py test.mo
                cp test.flat.py performancetest/newflat.py
                cp test.py performancetest/new.py
                cd performancetest
                TIMETAKEN=$(time (python new.py >/dev/null 2>&1) 2>&1)
                echo $length $TIMETAKEN >> nflat$2
                TIMETAKEN=$(time (python newflat.py >/dev/null 2>&1) 2>&1)
                echo $length $TIMETAKEN >> flat$2
        done
}

rm pydevs
ln -s ../../pydevs-old/pydevs pydevs
echo "Running Old Deep"
runsim createDeep.py "_OD"
echo ""
echo "Running Old Wide"
runsim create.py "_OW"
echo ""

rm pydevs
ln -s ../../pydevs-new/pydevs pydevs
echo "Running New Deep"
runsim createDeep.py "_ND"
echo ""
echo "Running New Wide"
runsim create.py "_NW"
echo ""
