package test2
  import devs.*;
  import externalfunctions.*;
  import simulator.*;
  class GeneratorState
    type Generator_SeqStates
      EnumType value;
      parameter StringType quantity="";
      parameter EnumType min=generating, max=generating;
      parameter EnumType start=generating;
      parameter BooleanType fixed=false;
      parameter BooleanType enable=true;
      constant EnumType generating;
    end Generator_SeqStates;
    Generator_SeqStates seqState(start=generating);
  end GeneratorState;
  class ProcessorState
    type Processor_SeqStates
      EnumType value;
      parameter StringType quantity="";
      parameter EnumType min=idle, max=state_2;
      parameter EnumType start=idle;
      parameter BooleanType fixed=false;
      parameter BooleanType enable=true;
      constant EnumType idle;
      constant EnumType state_2;
    end Processor_SeqStates;
    Processor_SeqStates seqState(start=idle);
  end ProcessorState;
  class Root
    extends AtomicDEVS;
    extends AtomicDEVS;
    extends AtomicDEVS;
    extends AtomicDEVS;
    output DevsPort p_out;
    dict X=dict();
    list timeLefts;
    Real elapsed=0;
    GeneratorState ins_0_state=GeneratorState();
    Real ins_0_totalWait=timeAdvance_Generator(ins_0_state);
    Real ins_0_timeLeft=ins_0_totalWait;
    ProcessorState ins_2_state=ProcessorState();
    Real ins_2_totalWait=timeAdvance_Processor(ins_2_state);
    Real ins_2_timeLeft=ins_2_totalWait;
    ProcessorState ins_6_ins_3_state=ProcessorState();
    Real ins_6_ins_3_totalWait=timeAdvance_Processor(ins_6_ins_3_state);
    Real ins_6_ins_3_timeLeft=ins_6_ins_3_totalWait;
    ProcessorState ins_6_ins_4_state=ProcessorState();
    Real ins_6_ins_4_totalWait=timeAdvance_Processor(ins_6_ins_4_state);
    Real ins_6_ins_4_timeLeft=ins_6_ins_4_totalWait;
    function intTransition_Generator
      input GeneratorState state;
    algorithm 
      if state.seqState == GeneratorState.generating then
        state.seqState := GeneratorState.generating;
      end if;
    end intTransition_Generator;
    function outputFnc_Generator
      DevsEvent evt=null;
      input GeneratorState state;
      output dict Y=dict();
    algorithm 
      if state.seqState == GeneratorState.generating then
        evt := Job(0.1);
        Y["p_out"] := evt;
      end if;
    end outputFnc_Generator;
    function timeAdvance_Generator
      output Integer timespan;
      input GeneratorState state;
    algorithm 
      if state.seqState == GeneratorState.generating then
        timespan := 1;
      end if;
    end timeAdvance_Generator;
    function extTransition_Processor
      input ProcessorState state;
      input dict X;
      input Integer elapsed;
    algorithm 
      if state.seqState == ProcessorState.idle then
        state.seqState := ProcessorState.state_2;
        event := X.get("p_in",None);
      end if;
    end extTransition_Processor;
    function intTransition_Processor
      input ProcessorState state;
    algorithm 
      if state.seqState == ProcessorState.state_2 then
        state.seqState := ProcessorState.idle;
      end if;
    end intTransition_Processor;
    function outputFnc_Processor
      DevsEvent evt=null;
      input ProcessorState state;
      output dict Y=dict();
    algorithm 
      if state.seqState == ProcessorState.state_2 then
        Y["p_out"] := event;
      end if;
    end outputFnc_Processor;
    function timeAdvance_Processor
      output Integer timespan;
      input ProcessorState state;
    algorithm 
      if state.seqState == ProcessorState.idle then
        timespan := INFINITY;
      end if;
      if state.seqState == ProcessorState.state_2 then
        timespan := event.jobSize;
      end if;
    end timeAdvance_Processor;
    function get_dstar
      output list dStar;
      Real minimal=0;
      list elems=list();
    algorithm 
      minimal := timeAdvance();
      if ins_0_timeLeft < minimal+1e-10 then
        elems.append(ins_0_state);
      end if;
      if ins_2_timeLeft < minimal+1e-10 then
        elems.append(ins_2_state);
      end if;
      if ins_6_ins_3_timeLeft < minimal+1e-10 then
        elems.append(ins_6_ins_3_state);
      end if;
      if ins_6_ins_4_timeLeft < minimal+1e-10 then
        elems.append(ins_6_ins_4_state);
      end if;
      if len(elems) > 1 then
        dStar := select(elems);
      else
        dStar := elems[0];
      end if;
    end get_dstar;
    function intTransition
      Integer counter=0;
      list new=list();
      list transitioned=list();
      list first=list();
      list elems=list();
      Real ta=0.0;
      dict Y_inst=dict();
      list dStar;
    algorithm 
      new := list();
      counter := 0;
      ins_0_timeLeft := ins_0_timeLeft-elapsed;
      ins_2_timeLeft := ins_2_timeLeft-elapsed;
      ins_6_ins_3_timeLeft := ins_6_ins_3_timeLeft-elapsed;
      ins_6_ins_4_timeLeft := ins_6_ins_4_timeLeft-elapsed;
      dStar := get_dstar();
      if dStar == ins_0_state then
        Y := outputFnc_Generator(ins_0_state);
        ins_0_state := intTransition_Generator(ins_0_state);
        Y := renamePorts(Y,"ins_0");
        Y := mapConnections(Y);
        ins_0_timeLeft := timeAdvance_Generator(ins_0_state);
        Y_inst := getInstances(Y,"ins_6_ins_3");
        elapsed := ins_6_ins_3_totalWait-ins_6_ins_3_timeLeft;
        ins_6_ins_3_state := extTransition_Processor(ins_6_ins_3_state,Y_inst,elapsed);
        ins_6_ins_3_timeLeft := timeAdvance_Processor(ins_6_ins_3_state);
        ins_6_ins_3_totalWait := ins_6_ins_3_timeLeft;
      end if;
      if dStar == ins_2_state then
        Y := outputFnc_Processor(ins_2_state);
        ins_2_state := intTransition_Processor(ins_2_state);
        Y := renamePorts(Y,"ins_2");
        Y := mapConnections(Y);
        ins_2_timeLeft := timeAdvance_Processor(ins_2_state);
      end if;
      if dStar == ins_6_ins_3_state then
        Y := outputFnc_Processor(ins_6_ins_3_state);
        ins_6_ins_3_state := intTransition_Processor(ins_6_ins_3_state);
        Y := renamePorts(Y,"ins_6_ins_3");
        Y := mapConnections(Y);
        ins_6_ins_3_timeLeft := timeAdvance_Processor(ins_6_ins_3_state);
        Y_inst := getInstances(Y,"ins_6_ins_4");
        elapsed := ins_6_ins_4_totalWait-ins_6_ins_4_timeLeft;
        ins_6_ins_4_state := extTransition_Processor(ins_6_ins_4_state,Y_inst,elapsed);
        ins_6_ins_4_timeLeft := timeAdvance_Processor(ins_6_ins_4_state);
        ins_6_ins_4_totalWait := ins_6_ins_4_timeLeft;
      end if;
      if dStar == ins_6_ins_4_state then
        Y := outputFnc_Processor(ins_6_ins_4_state);
        ins_6_ins_4_state := intTransition_Processor(ins_6_ins_4_state);
        Y := renamePorts(Y,"ins_6_ins_4");
        Y := mapConnections(Y);
        ins_6_ins_4_timeLeft := timeAdvance_Processor(ins_6_ins_4_state);
        Y_inst := getInstances(Y,"ins_2");
        elapsed := ins_2_totalWait-ins_2_timeLeft;
        ins_2_state := extTransition_Processor(ins_2_state,Y_inst,elapsed);
        ins_2_timeLeft := timeAdvance_Processor(ins_2_state);
        ins_2_totalWait := ins_2_timeLeft;
      end if;
    end intTransition;
    function select
      input list immChildren;
      output list child;
    algorithm 
      child := immChildren[0];
    end select;
    function extTransition
      input dict X;
      input Real elapsed;
      dict Y=dict();
      list keys=list();
      dict Y_inst=dict();
    algorithm 
      ins_0_timeLeft := ins_0_timeLeft-elapsed;
      ins_2_timeLeft := ins_2_timeLeft-elapsed;
      ins_6_ins_3_timeLeft := ins_6_ins_3_timeLeft-elapsed;
      ins_6_ins_4_timeLeft := ins_6_ins_4_timeLeft-elapsed;
      Y := mapConnections(X);
      keys := Y.keys();
      if keys.contains("ins_0") then
        Y_inst := getInstances(Y,"ins_0");
        elapsed := ins_0_totalWait-ins_0_timeLeft;
        ins_0_state := extTransition_Generator(ins_0_state,Y_inst,elapsed);
        ins_0_timeLeft := timeAdvance_Generator(ins_0_state);
        ins_0_totalWait := ins_0_timeLeft;
      end if;
      if keys.contains("ins_2") then
        Y_inst := getInstances(Y,"ins_2");
        elapsed := ins_2_totalWait-ins_2_timeLeft;
        ins_2_state := extTransition_Processor(ins_2_state,Y_inst,elapsed);
        ins_2_timeLeft := timeAdvance_Processor(ins_2_state);
        ins_2_totalWait := ins_2_timeLeft;
      end if;
      if keys.contains("ins_6_ins_3") then
        Y_inst := getInstances(Y,"ins_6_ins_3");
        elapsed := ins_6_ins_3_totalWait-ins_6_ins_3_timeLeft;
        ins_6_ins_3_state := extTransition_Processor(ins_6_ins_3_state,Y_inst,elapsed);
        ins_6_ins_3_timeLeft := timeAdvance_Processor(ins_6_ins_3_state);
        ins_6_ins_3_totalWait := ins_6_ins_3_timeLeft;
      end if;
      if keys.contains("ins_6_ins_4") then
        Y_inst := getInstances(Y,"ins_6_ins_4");
        elapsed := ins_6_ins_4_totalWait-ins_6_ins_4_timeLeft;
        ins_6_ins_4_state := extTransition_Processor(ins_6_ins_4_state,Y_inst,elapsed);
        ins_6_ins_4_timeLeft := timeAdvance_Processor(ins_6_ins_4_state);
        ins_6_ins_4_totalWait := ins_6_ins_4_timeLeft;
      end if;
    end extTransition;
    function timeAdvance
      output Real timeSpan;
    algorithm 
      timeLefts := list();
      timeLefts.append(ins_0_timeLeft);
      timeLefts.append(ins_2_timeLeft);
      timeLefts.append(ins_6_ins_3_timeLeft);
      timeLefts.append(ins_6_ins_4_timeLeft);
      timeSpan := min(timeLefts);
    end timeAdvance;
    function outputFnc
      dict outp=dict();
      list dStar;
    algorithm 
      dStar := get_dstar();
      if dStar == ins_0_state then
        outp := outputFnc_Generator(ins_0_state);
        outp := renamePorts(outp,"ins_0");
      end if;
      if dStar == ins_2_state then
        outp := outputFnc_Processor(ins_2_state);
        outp := renamePorts(outp,"ins_2");
      end if;
      if dStar == ins_6_ins_3_state then
        outp := outputFnc_Processor(ins_6_ins_3_state);
        outp := renamePorts(outp,"ins_6_ins_3");
      end if;
      if dStar == ins_6_ins_4_state then
        outp := outputFnc_Processor(ins_6_ins_4_state);
        outp := renamePorts(outp,"ins_6_ins_4");
      end if;
      outp := mapConnections(outp);
      poke(p_out,outp.get("p_out",None));
    end outputFnc;
    function mapConnections
      input dict X;
      output dict Y;
    algorithm 
      Y := dict();
      if X.__contains__("ins_6_ins_3_p_out") then
        Y["ins_6_ins_4_p_in"] := X["ins_6_ins_3_p_out"];
      end if;
      if X.__contains__("ins_6_ins_4_p_out") then
        Y["ins_2_p_in"] := X["ins_6_ins_4_p_out"];
      end if;
      if X.__contains__("ins_0_p_out") then
        Y["ins_6_ins_3_p_in"] := X["ins_0_p_out"];
      end if;
      if X.__contains__("ins_2_p_out") then
        Y["p_out"] := X["ins_2_p_out"];
      end if;
    end mapConnections;
    function getInstances
      input dict X;
      input String name;
      output dict Y;
      list keys;
      Integer counter;
      String key;
      String new_key;
      String searchname;
      Integer length;
    algorithm 
      Y := dict();
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        if key.__contains__(name) then
          searchname := name+"_";
          new_key := key.split(searchname);
          new_key := new_key[1];
          Y[new_key] := X[key];
        end if;
        counter := counter+1;
      end while;
    end getInstances;
    function renamePorts
      input dict X;
      input String name;
      output dict Y=dict();
      list keys=list();
      String newname="";
      String key="";
      Integer counter=0;
      Integer length=0;
    algorithm 
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        newname := name+"_"+key;
        Y[newname] := X[key];
        counter := counter+1;
      end while;
    end renamePorts;
  end Root;
  class Job
    extends DevsEvent;
    parameter Real jobSize;
  end Job;
  class Experiment
    extends DevsExperiment;
    Root rootModel();
    Simulator sim(simModel=rootModel);
    Boolean verbose=True;
    Boolean trace=False;
    Real end_time=100.0;
  end Experiment;
end test2;

package flatten
  import devs.*;
  class NewAtomic
    dict X=dict();
    list timeLefts;
    Real elapsed=0;
    function get_dstar
      output list dStar;
      Real minimal=0;
      list elems=list();
    algorithm 
      minimal := timeAdvance();
      if instA_timeLeft < minimal+1e-10 then
        elems.append(instA_state);
      end if;
      if len(elems) > 1 then
        dStar := select(elems);
      else
        dStar := elems[0];
      end if;
    end get_dstar;
    function new_intTransition
      Integer counter=0;
      list new=list();
      list transitioned=list();
      list first=list();
      list elems=list();
      Real ta=0.0;
      dict Y_inst=dict();
      list dStar;
    algorithm 
      new := list();
      counter := 0;
      instA_timeLeft := instA_timeLeft-elapsed;
      dStar := get_dstar();
      if dStar == instantiationA then
        Y := outputFnc_modelA(instantiationA_state);
        instantiationA_state := intTransition_modelA(instantiationA_state);
        Y := renamePorts(Y,instantiationA_name);
        Y := mapConnections(Y);
        instA_timeLeft := timeAdvance_modelA(instantiationA_state);
        Y_inst := getInstances(Y,"inst_A");
        elapsed := instA_totalWait-instA_timeLeft;
        instantiationB_state := extTransition_modelB(instantiationB_state,Y_inst,elapsed);
        instB_timeLeft := timeAdvance_modelB(instantiationB_state);
        instB_totalWait := instB_timeLeft;
      end if;
    end new_intTransition;
    function new_select
      input list immChildren;
      output list child;
    algorithm 
      child := immChildren[0];
    end new_select;
    function new_extTransition
      input dict X;
      input Real elapsed;
      dict Y=dict();
      list keys=list();
      dict Y_inst=dict();
    algorithm 
      instA_timeLeft := instA_timeLeft-elapsed;
      Y := mapConnections(X);
      keys := Y.keys();
      if keys.contains("inst_name") then
        Y_inst := getInstances(Y,"inst_A");
        elapsed := instA_totalWait-instA_timeLeft;
        instantiationB_state := extTransition_modelA(state_inst,Y_inst,elapsed);
        instA_timeLeft := timeAdvance_modelA(state_inst);
        instA_totalWait := instA_timeLeft;
      end if;
    end new_extTransition;
    function new_timeAdvance
      output Real timeSpan;
    algorithm 
      timeLefts := list();
      timeLefts.append(instA_timeLeft);
      timeSpan := min(timeLefts);
    end new_timeAdvance;
    function new_outputFnc
      dict outp=dict();
      list dStar;
    algorithm 
      dStar := get_dstar();
      if dStar == instantiationA then
        outp := outputFnc_modelA(instantiationA_state);
        outp := renamePorts(outp,instantiationA_name);
      end if;
      outp := mapConnections(outp);
      poke(outportA,outp.get("a",None));
    end new_outputFnc;
    function mapConnections
      input dict X;
      output dict Y;
    algorithm 
      Y := dict();
      if X.__contains__("b") then
        Y["a"] := X["b"];
      end if;
    end mapConnections;
    function getInstances
      input dict X;
      input String name;
      output dict Y;
      list keys;
      Integer counter;
      String key;
      String new_key;
      String searchname;
      Integer length;
    algorithm 
      Y := dict();
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        if key.__contains__(name) then
          searchname := name+"_";
          new_key := key.split(searchname);
          new_key := new_key[1];
          Y[new_key] := X[key];
        end if;
        counter := counter+1;
      end while;
    end getInstances;
    function renamePorts
      input dict X;
      input String name;
      output dict Y=dict();
      list keys=list();
      String newname="";
      String key="";
      Integer counter=0;
      Integer length=0;
    algorithm 
      keys := X.keys();
      counter := 0;
      length := keys.__len__();
      while counter<length loop
        key := keys[counter];
        newname := name+"_"+key;
        Y[newname] := X[key];
        counter := counter+1;
      end while;
    end renamePorts;
  end NewAtomic;
end flatten;

;